#!/bin/bash
# 
# This files is part of the "vesimulus" package
# (C) T. Geyer, 2010
# 
# run as:
# ./runner_b1.sh  <input file>  <dir with input file>   <label>

parmfile=$1

fish1=$2"/fish1_"$3".txt"
fish2=$2"/fish2_"$3".txt"
fishavg=$2"/fish_"$3"_avg.txt"

rm -f $fish1 $fish2 $fishavg

# set to vesimulus executable incl. relative path
VESIMULUS=../vesimulus

#### repeat simulations (2 * 10 = 20 times) ####
for k in 0 1 # 2 3
	do
	for i in 0 1 2 3 4 5 6 7 8 9
		do
		echo "+++ "$k$i" +++" > /dev/stderr
		
		nice -19 $VESIMULUS 5 0.01 10 $parmfile $2"/"$3 &>/dev/null
		
		if [ -e $fish1 ]
			then
			cut -f1,2 $2"/"$3"_pools.dat" | join $fish1 - > $fish2
			mv -f $fish2 $fish1
		else
			cut -f1,2  $2"/"$3"_pools.dat" > $fish1
		fi
	done
done

# average over the individual runs
gawk '{s=0}{for(i=2;i<=NF;i++){s=s+$i}}{print $1, s/(NF-1)}' $fish1 > $fishavg

#### analysis/scoring goes here.. ####
# :
# :
# echo $score
