#!/bin/bash
# 
# This files is part of the "vesimulus" package
# (C) T. Geyer, 2010
# 
# run as:
# ./runner_b7.sh  <input file>  <dir with input file>   <label>

parmfile=$1

fish1=$2"/fish1_"$3".txt"
fish2=$2"/fish2_"$3".txt"
fishavg=$2"/fish_"$3"_avg.txt"

rm -f $fish1 $fish2 $fishavg

# set to vesimulus executable incl. relative path
VESIMULUS=../vesimulus

#### repeat simulations (4 * 10 = 40 times) ####
for k in 0 1 2 3
	do
	for i in 0 1 2 3 4 5 6 7 8 9
		do
		echo "+++ "$k$i" +++" > /dev/stderr
		
		nice -19 $VESIMULUS 0.4 1.0e-4 2 $parmfile $2"/"$3 &>/dev/null
		
		# combine output
		if [ -e $fish1 ]
			then
			# col 3 => SpecialPair
			# cols 2 + 4 + 5 => total c2ox
			cut -f1-5 $2"/"$3"_pools.dat" | gawk '{print $1, $3, $2+$4+$5}' | join $fish1 - > $fish2
			mv -f $fish2 $fish1
		else
			cut -f1-5 $2"/"$3"_pools.dat" | gawk '{print $1, $3, $2+$4+$5}' > $fish1
		fi
	done
done

# average over the individual runs
gawk '{s=0;t=0}{for(i=2;i<=NF;i+=2){s=s+$i;t=t+$(i+1)}}{print $1, 2*s/(NF-1), 2*t/(NF-1)}' $fish1 > $fishavg

#### analysis/scoring goes here... ####
# :
# :
# echo $score_P  $score_c2ox
