#!/bin/bash
# 
# This files is part of the "vesimulus" package
# (C) T. Geyer, 2010
# 
# run as:
# ./runner_bc1.sh  <input file>  <dir with input file>   <label>

parmfile=$1

fish1=$2"/fish1_"$3".txt"
fish2=$2"/fish2_"$3".txt"
fishavg=$2"/fish_"$3"_avg.txt"

rm -f $fish1 $fish2 $fishavg

# set to vesimulus executable incl. relative path
VESIMULUS=../vesimulus

#### run simulation (only once) ####
for k in 0 #1 2 3
do
        for i in 0 #1 2 3 4 5 6 7 8 9
        do
		# echo "+++ "$k$i" +++" > /dev/stderr

		nice -19 $VESIMULUS 20 1 20 $parmfile $2"/"$3 &>/dev/null

               if [ -e $fish1 ]
                        then
                        tail -1 $2"/"$3"_pools.dat" | join $fish1 - > $fish2
                        mv -f $fish2 $fish1
                else
                        tail -1 $2"/"$3"_pools.dat" > $fish1
                fi

	done
done

#### average over multiple runs ####
avg=`gawk '{s=0}{for (i=2; i<=NF; i++){s+=$i}}{print s/(NF-1)}' $fish1`

echo "average = "$avg

