#include "observable.h"
#include "observableBC1Dimer2c2ox.h"

using namespace std;

// #define DEBUG

// Constructor
ObservableBC1Dimer2c2ox::ObservableBC1Dimer2c2ox(const string name) :
Observable::Observable(name)
{}


ObservableBC1Dimer2c2ox::~ObservableBC1Dimer2c2ox() { }


// loop over all proteins, identify bc1Dimer_2, and count oxidized c1s
double ObservableBC1Dimer2c2ox::get_value()
{
	string PName;
	unsigned long int oxidized=0, sum=0;
	
	list<Protein*>::iterator iter;
	ProteinBC1Dimer2* pp;
	
	#ifdef DEBUG
	cout << "ObservableBC1Dimer2c2ox:get_value: start" << endl;
	#endif
	
	for (iter = (*Proteins).begin(); iter != (*Proteins).end() ; iter++) {
		PName = (*iter)->readMyName();
		
		#ifdef DEBUG
		cout << "ObservableBC1Dimer2c2ox:get_value: PName = " << PName << endl;
		#endif
		
		if(PName.substr(0,9) == "bc1dimer2")
		{
			pp = static_cast<ProteinBC1Dimer2*>(*iter);
			oxidized += pp->get_c2ox();
			sum ++;

			#ifdef DEBUG
			cout << "ObservableBC1Dimer2c2ox:get_value: oxidized = " << oxidized << "  sum = " << sum << endl;
			#endif
		}
	}

	if(sum > 0) {
		return(static_cast<double>(oxidized));
	} else {
		return(0.0);
	}
}
