#include "observable.h"
#include "observableRCQbHe.h"

using namespace std;

// #define DEBUG


ObservableQbHe::ObservableQbHe(const string name) :
Observable::Observable(name)
{ }



// empty function - no pools required -- just a wrapper for debug output
void ObservableQbHe::verify_pools() {

	#ifdef DEBUG
	cout << "ObservableQbHe:verify_pools" << endl;
	#endif
	;
}


double ObservableQbHe::get_value()
{
	string PName;
	unsigned long int pairs=0, sum=0;
	
	list<Protein*>::iterator iter;
	ProteinRC* pp;
	
	#ifdef DEBUG
	cout << "ObservableQbHe:get_value: start" << endl;
	#endif
	
	for (iter = (*Proteins).begin(); iter != (*Proteins).end() ; iter++) {
		PName = (*iter)->readMyName();
		
		#ifdef DEBUG
		cout << "ObservableQbHe:get_value: PName = " << PName << endl;
		#endif
		
		if(PName.substr(0,3) == "RC_")
		{
			pp = static_cast<ProteinRC*>(*iter);
			if(pp->get_QHe() == 1) {
				pairs ++;
			}
			sum ++;

			#ifdef DEBUG
			cout << "ObservableQbHe:get_value: e-H-pairs = " << pairs << "  sum = " << sum << endl;
			#endif
		}
	}

	if(sum > 0) {
		return(static_cast<double>(pairs) / static_cast<double>(sum));
	} else {
		return(0);
	}
}
