// Definitions for the automated inclusion into the parser
// LABEL:		RC_c2ox
// CLASSNAME:	ObservableRCc2ox
// 
#ifndef OBSERVABLE_RCC2OX_H
#define OBSERVABLE_RCC2OX_H

#include "observable.h"
#include "proteinRC.h"
#include "parameter.h"
#include <math.h>

//! Observable that counts the number of oxidized c2 bound to an RC

//! Queries all proteins of type RC (i.e. RC_*).
//! There are no Parameters.

class ObservableRCc2ox : public Observable
{
	public:
	
	//! Constructor
	ObservableRCc2ox(const std::string name);
	//! Destructor
	~ObservableRCc2ox() { };

	//! Calculate and return the number of oxidized c2 bound to the RCs
	double get_value();

	//! Parser for setup line
	bool parseLine(char *linep) {return(true);}
	
	private:
		
	//! verify that all neccessary pools are defined -- no pools
	void verify_pools() { };

};
#endif /* OBSERVABLE_RCC2OX_H */
