#include"proteinBC1Dimer_2.h"

// #define DEBUG
// #define SCHWAETZ

// time step, resides in simulation.cpp
// extern double DELTA_T;

using namespace std;

ProteinBC1Dimer2::ProteinBC1Dimer2(const std::string name, const double &timestep) :
Protein::Protein(name, timestep)
{
	// initialize internals
	// dark adapted state: QH2 at Qo, Q at Qi, no c2 or H bound, FeS at cyt b, c1 reduced
	bs_Qo_1 = true;
	bs_Qo_2 = true;
	bs_Qi_1 = true;
	bs_Qi_2 = true;
	bs_c2_1 = false;
	bs_c2_2 = false;
	bs_H_1  = false;
	bs_H_2  = false;
	
	reg_e_Qo_1 = 2;
	reg_e_Qo_2 = 2;
	reg_H_Qo_1 = 2;
	reg_H_Qo_2 = 2;
	reg_e_Qi_1 = 0;
	reg_e_Qi_2 = 0;
	reg_H_Qi_1 = 0;
	reg_H_Qi_2 = 0;
	reg_e_c1_1 = 1;
	reg_e_c1_2 = 1;
	reg_e_c2_1 = 0;
	reg_e_c2_2 = 0;
	reg_e_FeS_1 = 0;
	reg_e_FeS_2 = 0;
	reg_e_bL_1 = 0;
	reg_e_bL_2 = 0;
	reg_e_bH_1 = 0;
	reg_e_bH_2 = 0;
	
	FeS_b_1 = true;
	FeS_b_2 = true;
	FeS_open_1 = false;
	FeS_open_2 = false;
	
   // pointer to function declarations:
   function fu1;
   
   void (Protein::*pr1) (Protein *) = (void(Protein::*)(Protein *))(&ProteinBC1Dimer2::R_A1);
   fu1.pfunction = pr1;
   setFunction("R_A1", fu1);
   
   void (Protein::*pr2) (Protein *) = (void(Protein::*)(Protein *))(&ProteinBC1Dimer2::R_D1);
   fu1.pfunction = pr2;
   setFunction("R_D1", fu1);
   
   void (Protein::*pr4) (Protein *) = (void(Protein::*)(Protein *))(&ProteinBC1Dimer2::R_A2);
   fu1.pfunction = pr4;
   setFunction("R_A2", fu1);
   
   void (Protein::*pr5) (Protein *) = (void(Protein::*)(Protein *))(&ProteinBC1Dimer2::R_D2);
   fu1.pfunction = pr5;
   setFunction("R_D2", fu1);
   
   void (Protein::*pr7) (Protein *) = (void(Protein::*)(Protein *))(&ProteinBC1Dimer2::R_A3);
   fu1.pfunction = pr7;
   setFunction("R_A3", fu1);
   
   void (Protein::*pr8) (Protein *) = (void(Protein::*)(Protein *))(&ProteinBC1Dimer2::R_D3_1);
   fu1.pfunction = pr8;
   setFunction("R_D3_1", fu1);
   
   void (Protein::*pr9) (Protein *) = (void(Protein::*)(Protein *))(&ProteinBC1Dimer2::R_D3_2);
   fu1.pfunction = pr9;
   setFunction("R_D3_2", fu1);
   
   void (Protein::*pr10) (Protein *) = (void(Protein::*)(Protein *))(&ProteinBC1Dimer2::R_A4);
   fu1.pfunction = pr10;
   setFunction("R_A4", fu1);
   
   void (Protein::*pr11a) (Protein *) = (void(Protein::*)(Protein *))(&ProteinBC1Dimer2::R_D4_1);
   fu1.pfunction = pr11a;
   setFunction("R_D4_1", fu1);
   
   void (Protein::*pr11s) (Protein *) = (void(Protein::*)(Protein *))(&ProteinBC1Dimer2::R_D4_2);
   fu1.pfunction = pr11s;
   setFunction("R_D4_2", fu1);
   
   void (Protein::*pr12) (Protein *) = (void(Protein::*)(Protein *))(&ProteinBC1Dimer2::R_R1);
   fu1.pfunction = pr12;
   setFunction("R_R1", fu1);
   
   void (Protein::*pr13) (Protein *) = (void(Protein::*)(Protein *))(&ProteinBC1Dimer2::R_R2a_1);
   fu1.pfunction = pr13;
   setFunction("R_R2a_1", fu1);
   
   void (Protein::*pr14) (Protein *) = (void(Protein::*)(Protein *))(&ProteinBC1Dimer2::R_R2b_1);
   fu1.pfunction = pr14;
   setFunction("R_R2b_1", fu1);
   
   void (Protein::*pr13b) (Protein *) = (void(Protein::*)(Protein *))(&ProteinBC1Dimer2::R_R2a_2);
   fu1.pfunction = pr13b;
   setFunction("R_R2a_2", fu1);
   
   void (Protein::*pr14b) (Protein *) = (void(Protein::*)(Protein *))(&ProteinBC1Dimer2::R_R2b_2);
   fu1.pfunction = pr14b;
   setFunction("R_R2b_2", fu1);
   
   void (Protein::*pr15) (Protein *) = (void(Protein::*)(Protein *))(&ProteinBC1Dimer2::R_R3);
   fu1.pfunction = pr15;
   setFunction("R_R3", fu1);
   
   void (Protein::*pr16) (Protein *) = (void(Protein::*)(Protein *))(&ProteinBC1Dimer2::R_R4);
   fu1.pfunction = pr16;
   setFunction("R_R4", fu1);
   
   void (Protein::*pr17) (Protein *) = (void(Protein::*)(Protein *))(&ProteinBC1Dimer2::R_R5);
   fu1.pfunction = pr17;
   setFunction("R_R5", fu1);
   
   void (Protein::*pr18) (Protein *) = (void(Protein::*)(Protein *))(&ProteinBC1Dimer2::R_R6);
   fu1.pfunction = pr18;
   setFunction("R_R6", fu1);
   
   void (Protein::*pr19) (Protein *) = (void(Protein::*)(Protein *))(&ProteinBC1Dimer2::R_R7);
   fu1.pfunction = pr19;
   setFunction("R_R7", fu1);

   timer_d3_1  = 0;
   timer_d3_2  = 0;
   timer_d4_1  = 0;
   timer_d4_2  = 0;
   timer_r2a_1 = 0;
   timer_r2a_2 = 0;
   timer_r2b_1 = 0;
   timer_r2b_2 = 0;
}



std::string ProteinBC1Dimer2::listInternals() {
	return(string("#time\tbs_Qo_1\tbs_Qo_2\tbs_Qi_1\tbs_Qi_2\tbs_c2_1\tbs_c2_2\tbs_H_1\tbs_H_2\treg_e_Qo_1\treg_e_Qo_2\treg_H_Qo_1\treg_H_Qo_2\treg_e_Qi_1\treg_e_Qi_2\treg_H_Qi_1\treg_H_Qi_2\treg_e_c1_1\treg_e_c1_2\treg_e_c2_1\treg_e_c2_2\treg_e_FeS_1\treg_e_FeS_2\treg_e_bL_1\treg_e_bL_2\treg_e_bH_1\treg_e_bH_2"));
}

void ProteinBC1Dimer2::writeInternals()
{
	if(outputInternals)
	{
		double realTime = timer * delta_t;
																   
		internalsOutFile.open(internalFileName.c_str(), fstream::app);
		internalsOutFile << realTime << "\t" << bs_Qo_1 << "\t" << bs_Qo_2 << "\t" << bs_Qi_1 << "\t" << bs_Qi_2 << "\t" << bs_c2_1 << "\t" << bs_c2_2 << "\t" << 
							bs_H_1 << "\t" << bs_H_2 << "\t" << reg_e_Qo_1 << "\t" << reg_e_Qo_2 << "\t" << reg_H_Qo_1 << "\t" << reg_H_Qo_2 << "\t" << 
							reg_e_Qi_1 << "\t" << reg_e_Qi_2 << "\t" << reg_H_Qi_1 << "\t" << reg_H_Qi_2 << "\t" << reg_e_c1_1 << "\t" << reg_e_c1_2 << "\t" << 
							reg_e_c2_1 << "\t" << reg_e_c2_2 << "\t" << reg_e_FeS_1 << "\t" << reg_e_FeS_2 << "\t" << reg_e_bL_1 << "\t" << reg_e_bL_2 << "\t" << 
							reg_e_bH_1 << "\t" << reg_e_bH_2 << "\n";
		internalsOutFile.close();
	}
}


void ProteinBC1Dimer2::verify_pools()
{
	if(!Pools->count(string(QoffPool))) {
		cerr << "ProteinBC1Dimer2::verify_pools: pool "<<QoffPool<<" not defined" << endl;
		exit(-3);
	}
	if(!Pools->count(string(QH2offPool))) {
		cerr << "ProteinBC1Dimer2::verify_pools: pool "<<QH2offPool<<" not defined" << endl;
		exit(-3);
	}
	if(!Pools->count(string(QonPool))) {
		cerr << "ProteinBC1Dimer2::verify_pools: pool "<<QonPool<<" not defined" << endl;
		exit(-3);
	}
	if(!Pools->count(string(QH2onPool))) {
		cerr << "ProteinBC1Dimer2::verify_pools: pool "<<QH2onPool<<" not defined" << endl;
		exit(-3);
	}
	if(!Pools->count(string(c2redPool))) {
		cerr << "ProteinBC1Dimer2::verify_pools: pool "<<c2redPool<<" not defined" << endl;
		exit(-3);
	}
	if(!Pools->count(string(c2oxPool))) {
		cerr << "ProteinBC1Dimer2::verify_pools: pool "<<c2oxPool<<" not defined" << endl;
		exit(-3);
	}
	if(!Pools->count(string(HoutsidePool))) {
		cerr << "ProteinBC1Dimer2::verify_pools: pool "<<HoutsidePool<<" not defined" << endl;
		exit(-3);
	}
	if(!Pools->count(string(HinsidePool))) {
		cerr << "ProteinBC1Dimer2::verify_pools: pool "<<HinsidePool<<" not defined" << endl;
		exit(-3);
	}
	
	if(!Observables->count(string(DeltaPhiObs))) {
		cerr << "ProteinBC1Dimer2::verify_pools: observable "<<DeltaPhiObs<<" not defined" << endl;
		exit(-3);
	}
	
	
	QoffPoolp     = getPool(QoffPool);
	QH2offPoolp   = getPool(QH2offPool);
	QonPoolp      = getPool(QonPool);
	QH2onPoolp    = getPool(QH2onPool);
	c2redPoolp    = getPool(c2redPool);
	c2oxPoolp     = getPool(c2oxPool);
	HoutsidePoolp = getPool(HoutsidePool);
	HinsidePoolp  = getPool(HinsidePool);
	
	DeltaPhiObsp  = getObservable(DeltaPhiObs);
}


bool ProteinBC1Dimer2::parseLine(char *linep)
{
	char  dummy[128];
	int num_of_proteins;
	
	if(sscanf(linep, "%s %d %s %lf %s %lf %lf %s %lf %s %lf %lf %s %lf %s %lf %s %lf %s %lf %lf %lf %lf %lf %lf %lf %s %lf %lf %lf", 
		dummy, &num_of_proteins, QH2onPool, &kon_QH2_Qo, QoffPool, &koff_Q_Qo, &k_Q_QoQi, QonPool, &kon_Q_Qi, QH2offPool, &koff_QH2_Qi, &k_QH2_QiQo, c2oxPool, &kon_c2ox_c1, c2redPool, 
			&koff_c2red_c1, HoutsidePool, &kon_H_Qi, HinsidePool, &koff_H_Qo, &k_e_QoFeS, &k_FeS_bc, &k_FeS_cb, &k_e_FeSc1, &k_e_c1c2, &k_e_QobL, DeltaPhiObs, &k_e_bLbH, &Phi0_e_bLbH, &k_e_bHQi) != 30) {
		cerr << "Simulation::parseFile: not enough parameters for bc1dimer_2 line >>" << linep << "<<" << endl;
		return(false);
	}
	// Sign check the rates
	if((kon_QH2_Qo<0) || (koff_Q_Qo<0) || (k_Q_QoQi<0) || (kon_Q_Qi<0) || (koff_QH2_Qi<0) || (k_QH2_QiQo<0) || (kon_c2ox_c1<0) || (koff_c2red_c1<0) || 
		(kon_H_Qi<0) || (koff_H_Qo<0) || (k_e_QoFeS<0) || (k_FeS_bc<0) || (k_FeS_cb<0) || (k_e_FeSc1<0) || (k_e_c1c2<0) || (k_e_QobL<0) || (k_e_bLbH<0) || 
		(Phi0_e_bLbH<0) || (k_e_bHQi<0)) {
			cerr << "Simulation::parseFile: negative rate constant in bc1dimer_2 line >>" << linep << "<<" << endl;
			return(false);
	}

	#ifdef SCHWAETZ
	cout << "------------------" << endl;
	cout << "   bc1dimer: read: " << num_of_proteins << endl;
	cout << "   bc1dimer: read: " << QH2onPool << "  " << kon_QH2_Qo << endl;
	cout << "   bc1dimer: read: " << QoffPool << "  " << koff_Q_Qo << "  " << k_Q_QoQi << endl;
	cout << "   bc1dimer: read: " << QonPool << "  " << kon_Q_Qi << endl;
	cout << "   bc1dimer: read: " << QH2offPool << "  " << koff_QH2_Qi << "  " << k_QH2_QiQo << endl;
	cout << "   bc1dimer: read: " << c2oxPool << "  " << kon_c2ox_c1 << endl;
	cout << "   bc1dimer: read: " << c2redPool << "  " << koff_c2red_c1 << endl;
	cout << "   bc1dimer: read: " << HoutsidePool << "  " << kon_H_Qi << endl;
	cout << "   bc1dimer: read: " << HinsidePool << "  " << koff_H_Qo << endl;
	cout << "   bc1dimer: read:                " << k_e_QoFeS << endl;
	cout << "   bc1dimer: read:                " << k_FeS_bc << "  " << k_FeS_cb << endl;
	cout << "   bc1dimer: read:                " << k_e_FeSc1 << "  " << k_e_c1c2 << endl;
	cout << "   bc1dimer: read:                " << k_e_QobL << endl;
	cout << "   bc1dimer: read: " << DeltaPhiObs << "  " << k_e_bHQi << "  " << Phi0_e_bLbH << endl;
	cout << "   bc1dimer: read:                " << k_e_bHQi << endl;
	#endif

	return(true);
}


// ++++++++++++++ internal reactions ++++++++++++++++++++++++

// A1: binds a QH2 molecule at either of the Qo sites
void ProteinBC1Dimer2::R_A1(Protein *p)
{
	if (!bs_Qo_1 && !bs_H_1)
		{
		if (QH2onPoolp->take_out(kon_QH2_Qo))
		{
			bs_Qo_1 = true;
			reg_e_Qo_1 = 2;		// now 2 e-H-pairs can be unloaded
			reg_H_Qo_1 = 2;
			writeInternals();
			#ifdef DEBUG
			cout << "\tProteinBC1Dimer2::R_A1: QH2 binding at Qo_1 done\n";
			#endif
		}
	}  

	if (!bs_Qo_2 && !bs_H_2)
		{
		if (QH2onPoolp->take_out(kon_QH2_Qo))
		{
			bs_Qo_2 = true;
			reg_e_Qo_2 = 2;		// now 2 e-H-pairs can be unloaded
			reg_H_Qo_2 = 2;
			writeInternals();
			#ifdef DEBUG
			cout << "\tProteinBC1Dimer2::R_A1: QH2 binding at Qo_2 done\n";
			#endif
		}
	}  
}


// D1: unbinding of emptied Q from Qo site and possible rebinding at Qi
void ProteinBC1Dimer2::R_D1(Protein *p)
{
	if (bs_Qo_1 && (reg_e_Qo_1 == 0))
	{
		// Q swaps directly to Qi
		if((!bs_Qi_2) && (lin_ran() <= (k_Q_QoQi * delta_t)))
		{
			bs_Qo_1   = false;
			bs_Qi_2   = true;
			reg_e_Qi_2 = 0;
			reg_H_Qi_2 = 0;
			writeInternals();
			#ifdef DEBUG
			cout << "\tProteinBC1Dimer2::R_D1: Qo_1 -> Qi_2 swapped\n";
			#endif
		}
		// or unbinds to pool
		else if(lin_ran() <= (koff_Q_Qo * delta_t))
		{
			QoffPoolp->put_back();
			bs_Qo_1 = false;
			writeInternals();
			#ifdef DEBUG
			cout << "\tProteinBC1Dimer2::R_D1: Qo_1 back to pool\n";
			#endif
		}
	}
	
	if (bs_Qo_2 && (reg_e_Qo_2 == 0))
	{
		// Q swaps directly to Qi
		if((!bs_Qi_1) && (lin_ran() <= (k_Q_QoQi * delta_t)))
		{
			bs_Qo_2   = false;
			bs_Qi_1   = true;
			reg_e_Qi_1 = 0;
			reg_H_Qi_1 = 0;
			writeInternals();
			#ifdef DEBUG
			cout << "\tProteinBC1Dimer2::R_D1: Qo_2 -> Qi_1 swapped\n";
			#endif
		}
		// or unbinds to pool
		else if(lin_ran() <= (koff_Q_Qo * delta_t))
		{
			QoffPoolp->put_back();
			bs_Qo_2 = false;
			writeInternals();
			#ifdef DEBUG
			cout << "\tProteinBC1Dimer2::R_D1: Qo_2 back to pool\n";
			#endif
		}
	}
}


// A2: bind proton from outside the vesicle onto Qi-/QiH-
void ProteinBC1Dimer2::R_A2(Protein *p)
{
	if (bs_Qi_1 && ((reg_e_Qi_1-reg_H_Qi_1)>=1))
	{
		if (HoutsidePoolp->take_out(kon_H_Qi))
		{
			reg_H_Qi_1++;
			writeInternals();
			#ifdef DEBUG
			cout << "\tProteinBC1Dimer2::R_A2: H+ bound from outside onto Qi_1\n";
			#endif
		}
	}
	
	if (bs_Qi_2 && ((reg_e_Qi_2-reg_H_Qi_2)>=1))
	{
		if (HoutsidePoolp->take_out(kon_H_Qi))
		{
			reg_H_Qi_2++;
			writeInternals();
			#ifdef DEBUG
			cout << "\tProteinBC1Dimer2::R_A2: H+ bound from outside onto Qi_2\n";
			#endif
		}
	}
}


// D2: H+ release into the vesicle when FeS has left cyt b
void ProteinBC1Dimer2::R_D2(Protein *p)
{
	if (bs_H_1 && FeS_open_1)
	{
		double dPhi = DeltaPhiObsp->get_value();
		double rate = koff_H_Qo * delta_t * exp(-dPhi / Phi0_e_bLbH);
		
		if(lin_ran() < (rate))
		{
			bs_H_1 = false;
			HinsidePoolp->put_back();
			HinsidePoolp->put_back();
			
			writeInternals();
			#ifdef DEBUG
			cout << "\tProteinBC1Dimer2::R_D2: H+ release from Qo_1 done\n";
			#endif
		}
	}
	
	if (bs_H_2 && FeS_open_2)
	{
		double dPhi = DeltaPhiObsp->get_value();
		double rate = koff_H_Qo * delta_t * exp(-dPhi / Phi0_e_bLbH);
		
		if(lin_ran() < (rate))
		{
			bs_H_2 = false;
			HinsidePoolp->put_back();
			HinsidePoolp->put_back();
			
			writeInternals();
			#ifdef DEBUG
			cout << "\tProteinBC1Dimer2::R_D2: H+ release from Qo_2 done\n";
			#endif
		}
	}
}

// A3: binds Q molecules at the Qi sites
void ProteinBC1Dimer2::R_A3(Protein *p)
{
	if (!bs_Qi_1)
		{
		if (QonPoolp->take_out(kon_Q_Qi))
		{
			bs_Qi_1   = true;
			reg_e_Qi_1 = 0;
			reg_H_Qi_1 = 0;
			writeInternals();
			#ifdef DEBUG
			cout << "\tProteinBC1Dimer2::R_A3: Q binding at Qi_1 done\n";
			#endif
		}
	}

	if (!bs_Qi_2)
		{
		if (QonPoolp->take_out(kon_Q_Qi))
		{
			bs_Qi_2   = true;
			reg_e_Qi_2 = 0;
			reg_H_Qi_2 = 0;
			writeInternals();
			#ifdef DEBUG
			cout << "\tProteinBC1Dimer2::R_A3: Q binding at Qi_2 done\n";
			#endif
		}
	}
}



// D3_1: unbinding of QH2 from Qi site #1
void ProteinBC1Dimer2::R_D3_1(Protein *p)
{
	if (bs_Qi_1 && (reg_e_Qi_1 == 2) && (reg_H_Qi_1 == 2))
	{
		switch(timer_d3_1)
		{
			case 0:
			{
				double t0 = 1.0/(koff_QH2_Qi * delta_t);
				timer_d3_1 = static_cast<unsigned long int>(exp_ran(t0));
				if(timer_d3_1 == 0) { timer_d3_1 = 1; }
				#ifdef DEBUG
				cout << "\tProteinBC1Dimer2::R_D3_1: QH2 unbinding started: time = " << timer_d3_1 << "\n";
				#endif
			}; break;
			case 1:
			{
				QH2offPoolp->put_back();
				bs_Qi_1   = false;
				reg_e_Qi_1 = 0;
				reg_H_Qi_1 = 0;
				writeInternals();
				timer_d3_1 = 0;
				#ifdef DEBUG
				cout << "\tProteinBC1Dimer2::R_D3_1: QH2 unbinding from Qi_1 done\n";
				#endif
			}; break;
			default: 
				timer_d3_1--;
		}
	}
}

// D3_2: unbinding of QH2 from Qi site #2
void ProteinBC1Dimer2::R_D3_2(Protein *p)
{
	if (bs_Qi_2 && (reg_e_Qi_2 == 2) && (reg_H_Qi_2 == 2))
	{
		switch(timer_d3_2)
		{
			case 0:
			{
				double t0 = 1.0/(koff_QH2_Qi * delta_t);
				timer_d3_2 = static_cast<unsigned long int>(exp_ran(t0));
				if(timer_d3_2 == 0) { timer_d3_2 = 1; }
				#ifdef DEBUG
				cout << "\tProteinBC1Dimer2::D3_2: QH2 unbinding started: time = " << timer_d3_2 << "\n";
				#endif
			}; break;
			case 1:
			{
				QH2offPoolp->put_back();
				bs_Qi_2 = false;
				reg_e_Qi_2 = 0;
				reg_H_Qi_2 = 0;
				writeInternals();
				timer_d3_2 = 0;
				#ifdef DEBUG
				cout << "\tProteinBC1Dimer2::R_D3_2: QH2 unbinding from Qi_2 done\n";
				#endif
			}; break;
			default: 
				timer_d3_2--;
		}
	}
}


// A4: binds an oxidized cytochrome c2 at reduced c1
// Only one c2 can be bound at a time
void ProteinBC1Dimer2::R_A4(Protein *p)
{
	if ((!bs_c2_1) && (!bs_c2_2))
	{
		// symmetric version: 2*kon
		if((reg_e_c1_1==1) && (reg_e_c1_2==1))
		{
			if (c2oxPoolp->take_out(2.0 * kon_c2ox_c1))
			{
				// left or right?
				if(lin_ran() < 0.5)
				{
					bs_c2_1  = true;
					reg_e_c2_1 = 0;
					
					writeInternals();
					#ifdef DEBUG
					cout << "\tProteinBC1Dimer2::R_A4: c2ox binding to c1_1 done\n";
					#endif
				} else {
					bs_c2_2  = true;
					reg_e_c2_2 = 0;
					
					writeInternals();
					#ifdef DEBUG
					cout << "\tProteinBC1Dimer2::R_A4: c2ox binding to c1_2 done\n";
					#endif
				}
			}
		}
		// only one c1 reduced
		else if((reg_e_c1_1==1) && (reg_e_c1_2==0))
		{
			if (c2oxPoolp->take_out(kon_c2ox_c1))
			{
				bs_c2_1  = true;
				reg_e_c2_1 = 0;
				
				writeInternals();
				#ifdef DEBUG
				cout << "\tProteinBC1Dimer2::R_A4: c2ox binding to c1_1 done\n";
				#endif
			}
		}
		else if((reg_e_c1_1==0) && (reg_e_c1_2==1))
		{
			if (c2oxPoolp->take_out(kon_c2ox_c1))
			{
				bs_c2_2  = true;
				reg_e_c2_2 = 0;
				
				writeInternals();
				#ifdef DEBUG
				cout << "\tProteinBC1Dimer2::R_A4: c2ox binding to c1_2 done\n";
				#endif
			}
		}
	}
}


// D4_1: unbinding of c2 from c2 site #1
void ProteinBC1Dimer2::R_D4_1(Protein *p)
{
	if (bs_c2_1 && (reg_e_c2_1 == 1))
	{
		switch(timer_d4_1)
		{
			case 0:
			{
				double t0 = 1.0/(koff_c2red_c1 * delta_t);
				timer_d4_1 = static_cast<unsigned long int>(exp_ran(t0));
				if(timer_d4_1 == 0) { timer_d4_1 = 1; }
				#ifdef DEBUG
				cout << "\tProteinBC1Dimer2::R_D4_1: c2 unbinding from c1_1 started: time = " << timer_d4_1 << "\n";
				#endif
			}; break;
			case 1:
			{
				c2redPoolp->put_back();
				bs_c2_1  = false;
				reg_e_c2_1 = 0;
				writeInternals();
				timer_d4_1 = 0;
				#ifdef DEBUG
				cout << "\tProteinBC1Dimer2::R_D4_1: c2 unbinding from c1_1 done\n";
				#endif
			}; break;
			default: 
				timer_d4_1--;
		}
	}
}

// D4_2: unbinding of c2 from c2 site #2
void ProteinBC1Dimer2::R_D4_2(Protein *p)
{
	if (bs_c2_2 && (reg_e_c2_2 == 1))
	{
		switch(timer_d4_2)
		{
			case 0:
			{
				double t0 = 1.0/(koff_c2red_c1 * delta_t);
				timer_d4_2 = static_cast<unsigned long int>(exp_ran(t0));
				if(timer_d4_2 == 0) { timer_d4_2 = 1; }
				#ifdef DEBUG
				cout << "\tProteinBC1Dimer2::R_D4_2: c2 unbinding from c1_2 started: time = " << timer_d4_2 << "\n";
				#endif
			}; break;
			case 1:
			{
				c2redPoolp->put_back();
				bs_c2_2 = false;
				reg_e_c2_2 = 0;
				writeInternals();
				timer_d4_2 = 0;
				#ifdef DEBUG
				cout << "\tProteinBC1Dimer2::R_D4_2: c2 unbinding from c1_2 done\n";
				#endif
			}; break;
			default: 
				timer_d4_2--;
		}
	}
}



// R1: electron transfer Qo -> FeS_b, concurrently the H+ are put onto the 
// H+ binding site for release
// This reaction may only occur after e-transfer Qo->bL (reg_e_Qo_1==1)
void ProteinBC1Dimer2::R_R1(Protein *p)
{
	if(bs_Qo_1 && (reg_e_Qo_1==1) && (reg_e_FeS_1==0) && !bs_H_1 && FeS_b_1 && (reg_e_bL_1==0))
	{
		if(lin_ran() < (k_e_QoFeS * delta_t))
		{
			reg_e_Qo_1--;
			// reg_H_Qi_1 == 0;  // <<<<<<<<<<<<<<<<<<<<<<< ????
			reg_e_FeS_1++;
			bs_H_1 = true;
			writeInternals();
			#ifdef DEBUG
			cout << "\tProteinBC1Dimer2::R_R1: electron transfer Qo_1 -> FeS_1 and H+ -> bsH_1 done\n";
			#endif
		}
	}
	
	if(bs_Qo_2 && (reg_e_Qo_2==1) && (reg_e_FeS_2==0) && !bs_H_2 && FeS_b_2 && (reg_e_bL_2==0))
	{
		if(lin_ran() < (k_e_QoFeS * delta_t))
		{
			reg_e_Qo_2--;
			// reg_H_Qi_2 == 0; // <<<<<<<<<<<<<<<<<<<< ????
			reg_e_FeS_2++;
			bs_H_2 = true;
			writeInternals();
			#ifdef DEBUG
			cout << "\tProteinBC1Dimer2::R_R1: electron transfer Qo_2 -> FeS_2 and H+ -> bsH_2 done\n";
			#endif
		}
	}
}


// R2a: Movement of the FeS domain cyt b -> cyt c1
void ProteinBC1Dimer2::R_R2a_1(Protein *p)
{
	if (FeS_b_1 && (reg_e_FeS_1==1) && (reg_e_c1_1==0))
	{
		double rate = k_FeS_bc * delta_t;
		
		if(lin_ran() < rate)
		{
			FeS_open_1 = true;
			FeS_b_1 = false;
		}
	}
}
void ProteinBC1Dimer2::R_R2a_2(Protein *p)
{
	if (FeS_b_2 && (reg_e_FeS_2==1) && (reg_e_c1_2==0))
	{
		double rate = k_FeS_bc * delta_t;
		
		if(lin_ran() < rate)
		{
			FeS_open_2 = true;
			FeS_b_2 = false;
		}
	}
}


// R2b: Movement of the FeS domain cyt c1 -> cyt b
void ProteinBC1Dimer2::R_R2b_1(Protein *p)
{
	if (!FeS_b_1 && (reg_e_FeS_1==0) && !bs_H_1)
	{
		switch(timer_r2b_1)
		{
			case 0:
			{
				double t0 = 1.0/(k_FeS_cb * delta_t);
				timer_r2b_1 = static_cast<unsigned long int>(exp_ran(t0));
				if(timer_r2b_1 == 0) { timer_r2b_1 = 1; }
				#ifdef DEBUG
				cout << "\tProteinBC1Dimer2::R_R2b_1: FeS swap c1_1->b_1 started: time = " << timer_r2b_1 << "\n";
				#endif
			}; break;
			case 1:
			{
				FeS_b_1 = true;
				FeS_open_1 = false;
				writeInternals();
				timer_r2b_1 = 0;
				#ifdef DEBUG
				cout << "\tProteinBC1Dimer2::R_R2a_1: FeS swap c1_1->b_1 done\n";
				#endif
			}; break;
			default: 
				timer_r2b_1--;
		}
	}
}

void ProteinBC1Dimer2::R_R2b_2(Protein *p)
{
	if (!FeS_b_2 && (reg_e_FeS_2==0) && !bs_H_2)
	{
		switch(timer_r2b_2)
		{
			case 0:
			{
				double t0 = 1.0/(k_FeS_cb * delta_t);
				timer_r2b_2 = static_cast<unsigned long int>(exp_ran(t0));
				if(timer_r2b_2 == 0) { timer_r2b_2 = 1; }
				#ifdef DEBUG
				cout << "\tProteinBC1Dimer2::R_R2b_2: FeS swap c1_2->b_2 started: time = " << timer_r2b_2 << "\n";
				#endif
			}; break;
			case 1:
			{
				FeS_b_2 = true;
				FeS_open_2 = false;
				writeInternals();
				timer_r2b_2 = 0;
				#ifdef DEBUG
				cout << "\tProteinBC1Dimer2::R_R2a_2: FeS swap c1_2->b_2 done\n";
				#endif
			}; break;
			default: 
				timer_r2b_2--;
		}
	}
}


// R3: e- transfer FeS -> c1
void ProteinBC1Dimer2::R_R3(Protein *p)
{
	if (!FeS_b_1 && (reg_e_FeS_1==1) && (reg_e_c1_1==0))
	{
		if(lin_ran() < (k_e_FeSc1 * delta_t))
		{
			reg_e_FeS_1 = 0;
			reg_e_c1_1  = 1;
			long int eins = 1;
			
			writeInternals();
			#ifdef DEBUG
			cout << "\tProteinBC1Dimer2::R_R3: e- transfer FeS_1 -> c1_1 done\n";
			#endif
		}
	}
	
	if (!FeS_b_2 && (reg_e_FeS_2==1) && (reg_e_c1_2==0))
	{
		if(lin_ran() < (k_e_FeSc1 * delta_t))
		{
			reg_e_FeS_2 = 0;
			reg_e_c1_2  = 1;
			long int eins = 1;
			
			writeInternals();
			#ifdef DEBUG
			cout << "\tProteinBC1Dimer2::R_R3: e- transfer FeS_2 -> c1_2 done\n";
			#endif
		}
	}
}


// R4: e- transfer c1 -> c2
void ProteinBC1Dimer2::R_R4(Protein *p)
{
	if ((reg_e_c1_1==1) && bs_c2_1 && (reg_e_c2_1==0))
	{
		if(lin_ran() < (k_e_c1c2 * delta_t))
		{
			reg_e_c2_1 = 1;
			reg_e_c1_1 = 0;

			writeInternals();
			#ifdef DEBUG
			cout << "\tProteinBC1Dimer2::R_R4: e- transfer c1_1 -> c2_1 done\n";
			#endif
		}
	}
	
	if ((reg_e_c1_2==1) && bs_c2_2 && (reg_e_c2_2==0))
	{
		if(lin_ran() < (k_e_c1c2 * delta_t))
		{
			reg_e_c2_2 = 1;
			reg_e_c1_2 = 0;
			
			writeInternals();
			#ifdef DEBUG
			cout << "\tProteinBC1Dimer2::R_R4: e- transfer c1_2 -> c2_2 done\n";
			#endif
		}
	}
}


// R5: e- transfer Qo -> bL
// This reaction occurs before e-transfer Qo->FeS (reg_e_Qo_1==2)
void ProteinBC1Dimer2::R_R5(Protein *p)
{
	if ((reg_e_Qo_1==2) && bs_Qo_1 && (reg_e_bL_1==0))
	{
		if(lin_ran() < (k_e_QobL * delta_t))
		{
			reg_e_Qo_1--;
			reg_e_bL_1 = 1;
			
			writeInternals();
			#ifdef DEBUG
			cout << "\tProteinBC1Dimer2::R_R5: e- transfer Qo_1 -> bL_1 done\n";
			#endif
		}
	}
	
	if ((reg_e_Qo_2==2) && bs_Qo_2 && (reg_e_bL_2==0))
	{
		if(lin_ran() < (k_e_QobL * delta_t))
		{
			reg_e_Qo_2--;
			reg_e_bL_2 = 1;
			
			writeInternals();
			#ifdef DEBUG
			cout << "\tProteinBC1Dimer2::R_R5: e- transfer Qo_2 -> bL_2 done\n";
			#endif
		}
	}
}


// R6: electron transfer from bL -> bH
// this reaction is limited by \delta \Phi
void ProteinBC1Dimer2::R_R6(Protein *p)
{
	if((reg_e_bL_1==1) && (reg_e_bH_1==0))
	{
		double dPhi = DeltaPhiObsp->get_value();
		double rate = k_e_bLbH * delta_t * exp(-dPhi / Phi0_e_bLbH);
		
		if(lin_ran() < rate)
		{
			reg_e_bL_1 = 0;
			reg_e_bH_1 = 1;
			writeInternals();
			#ifdef DEBUG
			cout << "\tProteinBC1Dimer2::R_R6: electron transfer bL_1 -> bH_1 done\n";
			#endif
		}
	}
	
	if((reg_e_bL_2 == 1) && (reg_e_bH_2 == 0))
	{
		double dPhi = DeltaPhiObsp->get_value();
		double rate = k_e_bLbH * delta_t * exp(-dPhi / Phi0_e_bLbH);

		if(lin_ran() < rate)
		{
			reg_e_bL_2 = 0;
			reg_e_bH_2 = 1;
			writeInternals();
			#ifdef DEBUG
			cout << "\tProteinBC1Dimer2::R_R6: electron transfer bL-2 -> bH_2 done\n";
			#endif
		}
	}
}


// R7: e- transfer bH -> Qi
void ProteinBC1Dimer2::R_R7(Protein *p)
{
	if (bs_Qi_1 && (reg_e_Qi_1<2) && (reg_e_bH_1==1))
	{
		if(lin_ran() < (k_e_bHQi * delta_t))
		{
			reg_e_Qi_1++;
			reg_e_bH_1 = 0;
			
			writeInternals();
			#ifdef DEBUG
			cout << "\tProteinBC1Dimer2::R_R7: e- transfer bH_1 -> Qi_1 done\n";
			#endif
		}
	}
	
	if (bs_Qi_2 && (reg_e_Qi_2<2) && (reg_e_bH_2==1))
	{
		if(lin_ran() < (k_e_bHQi * delta_t))
		{
			reg_e_Qi_2++;
			reg_e_bH_2 = 0;
			
			writeInternals();
			#ifdef DEBUG
			cout << "\tProteinBC1Dimer2::R_R7: e- transfer bH_2 -> Qi_2 done\n";
			#endif
		}
	}
}
